
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>

#include "beta.h"

int main(int argc, char **argv)
{
    int i, j, m, n, nrep, mhat, nhat, dsize, k = 100;
    double *x;
    sbeta_mle b;
    gsl_rng *r = gsl_rng_alloc(gsl_rng_mt19937);
    gsl_rng_set(r, (unsigned long int) time(NULL));
    if (argc != 6) {
	printf("\nUsage: %s m n dsize nrep k\n\n", argv[0]);
	return 1;
    }
    m = atoi(argv[1]);
    n = atoi(argv[2]);
    dsize = atoi(argv[3]);
    nrep = atoi(argv[4]);
    k = atoi(argv[5]);
    if (dsize > 0) {
	x = (double *) malloc(dsize * sizeof(double));
	for (i = 0; i < nrep; i++) {
	    for (j = 0; j < dsize; j++) {
		x[j] = gsl_ran_beta(r, (double) m, (double) n);
	    }
	    b = beta_mle(x, dsize, 2 * k);
	    printf("%d %d %f\n", b.mhat, b.nhat, b.maxll);
	}
    }
    free(x);
    gsl_rng_free(r);
    return 0;
}

